# Drops of Jupiter Make Art
# Caitlyn Yee
import board, adafruit_mpr121, time, audiomixer, audiocore, mount_sd
from audiocore import WaveFile
from audiopwmio import PWMAudioOut as AudioOut

# Setup i2c on the Pico w/STEMMA_QT wired as shown in the diagram - GP4 (SDA/Blue), GP5 (SCL/Yellow, Power 3.3v(Out) Red
i2c = board.STEMMA_I2C() # Same for any board w/built-in STEMMA_QT port
touch_pad = adafruit_mpr121.MPR121(i2c)

# set up touchpads
touch_pad = adafruit_mpr121.MPR121(i2c)

audio = AudioOut(board.GP15) # I'm using GP15 for audio in. CHANGE if you use a different pin.

path = "/sd/drops/"

# MUST have 12 beats if using MPR121 touchpad breakout. Also make sure these 12 names match
# the files in your folder, named in the path, above. Otherwise modify the names.
beats = ["ana.wav",
         "angie.wav",
         "annabel.wav",
         "becca.wav",
         "cait.wav",
         "chuck.wav",
         "davina.wav",
         "jacob.wav",
         "john.wav",
         "meg.wav",
         "ryan.wav",
         "topher.wav"
        ]



# Should be 12 voices
num_voices = len(beats)

# create Mixer and attach to audio playback
# Get Audio Mixer working
mixer = audiomixer.Mixer(voice_count=num_voices, sample_rate=8000, channel_count=1, bits_per_sample=16, samples_signed=True)
audio.play(mixer)

# To use audio mixer and play tracks simultaneously, uncomment the following two blocks of code
# read in all beats & simultaneously play them at audio sound .level = 0 (no volume)
#for i in range(len(beats)):
#    print(beats[i])
#    wave = WaveFile(open(path+beats[i],"rb"))
#    mixer.voice[i].play(wave, loop=False )
#    mixer.voice[i].level = 1.0
#    time.sleep(3.0)
#    mixer.voice[i].level = 0.0

#while True:
#    for i in range(len(beats)):
#        if touch_pad[i].value:
#            print("pressing", i)
#            print(beats[i])

#            wave = WaveFile(open(path+beats[i],"rb"))
#            mixer.voice[i].play(wave, loop=False )
#            mixer.voice[i].level = 1.0 # When touched, increase to full volume
#        else:
#            mixer.voice[i].level = 0.0# No touch, then set volume back to zero

def play_sound(filename, pad_number):
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            if not touch_pad[pad_number].value:
                audio.stop()

while True:
    for i in range(len(beats)):
        if touch_pad[i].value:
           print("touching this pad", i)
           play_sound(beats[i], i) # play sound for that pad
